#include<bits/stdc++.h>
using namespace std;
int m[1000000];
int ans;
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int n;
    cin>>n;
    for(int i=0;i<n;i++)
    {
        cin>>m[i];
    }
    stack<pair<int,int>>st;
    for(int i=0;i<n;i++)
    {
        int br=0;
        while(!st.empty()&&st.top().first<m[i])
        {
            br+=st.top().second+1;
            st.pop();
        }
        st.push({m[i],br});
        ans+=br;
    }
    while(!st.empty())
    {
        st.pop();
    }
    for(int i=n-1;i>=0;i--)
    {
        int br=0;
        while(!st.empty()&&st.top().first<m[i])
        {
            br+=st.top().second+1;
            st.pop();
        }
        st.push({m[i],br});
        ans+=br;
    }
    cout<<ans;
    return 0;
}
